﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Phone地图.Resources;
using Microsoft.Phone.Maps.Controls;
using System.Device.Location;
using System.Windows.Shapes;
using System.Windows.Media;
using Windows.Devices.Geolocation;

namespace Phone地图
{
    public partial class MainPage : PhoneApplicationPage
    {
        // 构造函数
        public MainPage()
        {
            InitializeComponent();
            //Map MyMap = new Map();
            //ContentPanel.Children.Add(MyMap);
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            //以抛物线的方式，把视角定位到光谷软件园中心湖上空。
            MyMap.SetView(new GeoCoordinate(30.476724, 114.406563), 16, MapAnimationKind.Parabolic);
        }

        //切换制图模式
        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            switch (MyMap.CartographicMode)
            {
                case MapCartographicMode.Aerial:
                    MyMap.CartographicMode = MapCartographicMode.Hybrid;
                    break;
                case MapCartographicMode.Hybrid:
                    MyMap.CartographicMode = MapCartographicMode.Road;
                    break;
                case MapCartographicMode.Road:
                    MyMap.CartographicMode = MapCartographicMode.Terrain;
                    break;
                case MapCartographicMode.Terrain:
                    MyMap.CartographicMode = MapCartographicMode.Aerial;
                    break;
            }
        }

        //切换颜色模式
        private void Button_Click_3(object sender, RoutedEventArgs e)
        {
            if (MyMap.ColorMode == MapColorMode.Light)
                MyMap.ColorMode = MapColorMode.Dark;
            else MyMap.ColorMode = MapColorMode.Light;
        }

        //添加其他控件到地图，标识我的当前位置
        private async void Button_Click_4(object sender, RoutedEventArgs e)
        {
            //获取我的地理位置
            Geolocator myGeolocator = new Geolocator();
            //精度
            myGeolocator.DesiredAccuracyInMeters = 1;
            Geoposition myGeoposition = await myGeolocator.GetGeopositionAsync();
            Geocoordinate myGeocoordinate = myGeoposition.Coordinate;
            //转换经纬度GeoCoordinate
            GeoCoordinate myGeoCoordinate =  CoordinateConverter.ConvertGeocoordinate(myGeocoordinate);

            //MessageBox.Show(myGeoCoordinate.ToString());

            //定位地图到我的位置
            MyMap.SetView(myGeoCoordinate, 16, MapAnimationKind.Parabolic);

            //画一个正方形，然后渲染在地图的我的当前位置上
            Rectangle MyRectangle = new Rectangle();
            MyRectangle.Fill = new SolidColorBrush(Colors.Black);
            MyRectangle.Height = 20;
            MyRectangle.Width = 20;

            MapOverlay MyOverlay = new MapOverlay();
            MyOverlay.Content = MyRectangle;
            MyOverlay.GeoCoordinate = myGeoCoordinate;
            MyOverlay.PositionOrigin = new Point(0, 0.5);

            MapLayer MyLayer = new MapLayer();
            MyLayer.Add(MyOverlay);
            MyMap.Layers.Add(MyLayer);

        }




    }
}